<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Command Line Scripts (CLI)</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="command-line-scripts-cli">Command Line Scripts (CLI)</h1>
<p>Cacti supports a number of command line scripts. You will find them in the <code>./cli</code> directory. The CLI scripts fall into multiple categories, they include:</p>
<ul>
<li><strong>Automation</strong> - Utilities to help automate adding objects to Cacti</li>
<li><strong>Maintenance</strong> - Utilities to help keep Cacti healthy</li>
<li><strong>Repair</strong> - Utilities to help with repairing Cacti database components</li>
<li><strong>Repair/Migration</strong> - Utilities to help with repairing or migrating Cacti components</li>
<li><strong>Install/Upgrade</strong> - Utilities to help with installing and upgrading Cacti</li>
</ul>
<p>In the table below, each of the CLI scripts are categories and explained briefly.</p>
<h2 id="automation-scripts">Automation Scripts</h2>
<table>
<thead>
<tr class="header">
<th>Script</th>
<th>Category</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>add_device.php</td>
<td>Automation</td>
<td>Allows adding a Device to Cacti. Most device options are included. Some plugin options may not.</td>
</tr>
<tr class="even">
<td>add_data_query.php</td>
<td>Automation</td>
<td>Allows adding a Data Query to Cacti.</td>
</tr>
<tr class="odd">
<td>add_graph_template.php</td>
<td>Automation</td>
<td>Allows adding a Graph Template to Cacti.</td>
</tr>
<tr class="even">
<td>add_graphs.php</td>
<td>Automation</td>
<td>Allows adding a Graph to Cacti.</td>
</tr>
<tr class="odd">
<td>add_perms.php</td>
<td>Automation</td>
<td>Allows adding permissions to Cacti.</td>
</tr>
<tr class="even">
<td>add_tree.php</td>
<td>Automation</td>
<td>Allows adding tree's tree branches and objects to Cacti Trees.</td>
</tr>
<tr class="odd">
<td>copy_user.php</td>
<td>Maintenance</td>
<td>Allows creating new users from Templates</td>
</tr>
</tbody>
</table>
<h2 id="maintenance-scripts">Maintenance Scripts</h2>
<table>
<thead>
<tr class="header">
<th>Script</th>
<th>Category</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>input_whitelist.php</td>
<td>Maintenance</td>
<td>To to onboard new Data Input Methods when using Cacti in a high security environment where new Data Input Methods must always be vetted before enabling for general use.</td>
</tr>
<tr class="even">
<td>poller_graphs_reapply_names.php</td>
<td>Maintenance</td>
<td>Allows selecting re-running of Cacti's suggested values engine for Graphs</td>
</tr>
<tr class="odd">
<td>poller_reindex_hosts.php</td>
<td>Maintenance</td>
<td>Batch method to re-index Cacti Devices</td>
</tr>
<tr class="even">
<td>analyze_database.php</td>
<td>Maintenance</td>
<td>Analyzes all Cacti tables rebuilding their index cardinality. Important to run after having added large numbers of Devices and Graphs to Cacti.</td>
</tr>
</tbody>
</table>
<h2 id="repair-scripts">Repair Scripts</h2>
<table>
<thead>
<tr class="header">
<th>Script</th>
<th>Category</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>poller_output_empty.php</td>
<td>Repair</td>
<td>Removes bad entries from Cacti's poller output table.</td>
</tr>
<tr class="even">
<td>rebuild_poller_cache.php</td>
<td>Repair</td>
<td>Batch process to re-populate Cacti's poller cache. NOTE: This script can run for a very long time on large systems.</td>
</tr>
<tr class="odd">
<td>repair_database.php</td>
<td>Repair</td>
<td>Utility to look for common problems with old Cacti databases where objects were removed while still in use. Also rapairs all tables after a system crash.</td>
</tr>
<tr class="even">
<td>repair_graphs.php</td>
<td>Repair</td>
<td>Utility to repair Cacti Graphs whose structure is damaged due to legacy Cacti behavior.</td>
</tr>
<tr class="odd">
<td>repair_templates.php</td>
<td>Repair</td>
<td>Utility to repair Cacti Templates whose structure was damaged due to legacy Cacti behavior.</td>
</tr>
</tbody>
</table>
<h2 id="repairmigration-scripts">Repair/Migration Scripts</h2>
<table>
<thead>
<tr class="header">
<th>Script</th>
<th>Category</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>audit_database.php</td>
<td>Repair/Migration</td>
<td>Script to audit your Cacti schema, and repair any tables that don't match the stock Cacti schema. It will also upgrade the Cacti schema and run plugin upgrade functions. This is a good migration tool to move database from old versions of Cacti.</td>
</tr>
<tr class="even">
<td>convert_tables.php</td>
<td>Repair/Migration</td>
<td>Convert all tables from their current form to the Cacti preferred table type, collation and charset</td>
</tr>
<tr class="odd">
<td>splice_rra.php</td>
<td>Migration</td>
<td>Utility that allows two RRDfiles to be merged, and also assists with resampling an old RRDfile to a new RRA configuration, for example moving a Cacti system from 5 minute polling to 1 minute polling.</td>
</tr>
</tbody>
</table>
<h2 id="installupgrade-scripts">Install/Upgrade Scripts</h2>
<table>
<thead>
<tr class="header">
<th>Script</th>
<th>Category</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>import_package.php</td>
<td>Install/Upgrade</td>
<td>Import a Cacti package from a tgz file.</td>
</tr>
<tr class="even">
<td>install_cacti.php</td>
<td>Install/Upgrade</td>
<td>Script to install Cacti from a raw schema. Used primarily by distribution maintainers.</td>
</tr>
<tr class="odd">
<td>md5sum.php</td>
<td>Install/Upgrade</td>
<td>Utility to verify the MD5SUM of a file.</td>
</tr>
<tr class="even">
<td>sqltable_to_php.php</td>
<td>Install/Upgrade</td>
<td>Utility for Plugin Developers to create an object for creating tables in plugins.</td>
</tr>
<tr class="odd">
<td>structure_rra_paths.php</td>
<td>Install/Upgrade</td>
<td>Utility to convert a system from a flat directory path to a heirarchial one. Important for certain file systems that don't perform well when there are tens or hundreds of thousands of files in a single directory.</td>
</tr>
<tr class="even">
<td>upgrade_database.php</td>
<td>Install/Upgrade</td>
<td>Utility to upgrade a Cacti database from a point in time to the current release. Or even rerun the database upgrade from a point in the past to catch up with changes. This script should be used in conjunction with the <code>audit_database.php --repair --upgrade</code> option.</td>
</tr>
</tbody>
</table>
<blockquote>
<p><strong>NOTE</strong>: Package maintainers may wish to utilize the CLI methods of install_cacti.php and upgrade_database.php to perform in place installations and upgrades.</p>
</blockquote>
<blockquote>
<p><strong>Caution</strong>: In the following examples, several numbers are shown as output from various scripts. They will vary between different installations. So don't bother, if your numbers will vary.</p>
</blockquote>
<p>In the sub-sections below, we will demonstrate the use of a few of these CLI scripts.</p>
<h2 id="rebuild-poller-cache">Rebuild Poller Cache</h2>
<p>The poller cache holds all commands that cacti will issue during the polling process in an internal format. It is possible, to review the current contents of the poller cache by visiting <code>System Utilities</code>, <code>View Poller Cache</code>. It is possible to apply filters to this view; it will show up like</p>
<pre class="console"><code>Localhost - Hard Drive Space    Script Server: /var/www/html/cacti/scripts/ss_host_disk.php ss_host_disk 127.0.0.1 1 1:161:500:somesecret:::::: get total 6
                                RRD: /var/www/html/cacti/rra/localhost_hdd_total_61.rrd
Localhost - Load Average        Script: /usr/bin/perl /var/www/html/cacti/scripts/loadavg_multi.pl
                                RRD: /var/www/html/cacti/rra/localhost_load_1min_5.rrd
Localhost - Logged in Users     Script: /usr/bin/perl /var/www/html/cacti/scripts/unix_users.pl
                                RRD: /var/www/html/cacti/rra/localhost_users_6.rrd
Localhost - Memory - Free       Script: /usr/bin/perl /var/www/html/cacti/scripts/linux_memory.pl MemFree:
                                RRD: /var/www/html/cacti/rra/localhost_mem_buffers_3.rrd
Localhost - Memory - Free Swap  Script: /usr/bin/perl /var/www/html/cacti/scripts/linux_memory.pl SwapFree:
                                RRD: /var/www/html/cacti/rra/localhost_mem_swap_4.rrd
Localhost - mtaReceivedMessages SNMP Version: 1, Community: somesecret, OID: .1.3.6.1.2.1.28.1.1.1.1
                                RRD: /var/www/html/cacti/rra/localhost_mtareceivedmessages_47.rrd
Localhost - mtaReceivedVolume   SNMP Version: 1, Community: somesecret, OID: .1.3.6.1.2.1.28.1.1.4.1
                                RRD: /var/www/html/cacti/rra/localhost_mtareceivedvolume_49.rrd
</code></pre>
<p>There are several circumstances, that may result in the poller cache being out of sync. An example would be a change of the name of a script used in a <code>Data Input Method</code>. This change is <em>not</em> automatically propagated to the poller cache. It is required, to run <code>php -q rebuild poller_cache.php</code> manually.</p>
<p>Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q rebuild_poller_cache.php --help
Cacti Rebuild Poller Cache Script 1.0, Copyright 2004-2018 - The Cacti Group

usage: rebuild_poller_cache.php [-d] [-h] [--help] [-v] [--version]

-d            - Display verbose output during execution
-v --version  - Display this help message
-h --help     - Display this help message
</code></pre>
<p>Debug mode lists the data sources items that are worked upon.</p>
<pre class="console"><code>shell&gt;php -q rebuild_poller_cache.php -d
WARNING: Do not interrupt this script.  Rebuilding the Poller Cache can take quite some time
DEBUG: There are &#39;38&#39; data source elements to update.
DEBUG: Data Source Item &#39;1&#39; of &#39;38&#39; updated
DEBUG: Data Source Item &#39;2&#39; of &#39;38&#39; updated
DEBUG: Data Source Item &#39;3&#39; of &#39;38&#39; updated
DEBUG: Data Source Item &#39;4&#39; of &#39;38&#39; updated
....
</code></pre>
<p>Without any parameter, some dots are shown as progress indicators.</p>
<pre class="console"><code>shell&gt;php -q rebuild_poller_cache.php
WARNING: Do not interrupt this script.  Rebuilding the Poller Cache can take quite some time
......................................
shell&gt;
</code></pre>
<blockquote>
<p><strong>Caution</strong></p>
<p>Rebuilding the poller cache interferes with the poller operation. Make sure that the poller is not running and will not start during a rebuild operation</p>
</blockquote>
<h2 id="re-index-hosts">Re-Index Hosts</h2>
<p>Re-Indexing is required only for SNMP/Script Data Queries. Remember, that when applying a Data Query to a Host, a <code>Re-Index Method</code> has to be chosen. This reindex method governs the automatic re-indexing based on specific events.</p>
<h6 id="table-20-1-re-index-methods">Table 20-1. Re-Index Methods</h6>
<table>
<thead>
<tr class="header">
<th>Re-Index Method</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Uptime Goes Backwards</td>
<td>Refers to a system reboot</td>
</tr>
<tr class="even">
<td>Index Count Changed</td>
<td>Refers to a change of the number of indexed items</td>
</tr>
<tr class="odd">
<td>Verify All Fields</td>
<td>All index fields of the according XML file are checked for changes</td>
</tr>
</tbody>
</table>
<p>If the method is set to <code>Uptime Goes Backwards</code>, Cacti will detect if the target has been rebooted by querying sysUptime (.1.3.6.1.2.1.1.3.0). If the current value for the uptime is lower than the previous one (uptime goes backwards), a reboot is assumed and a re-index is performed</p>
<p>If the method is set to <code>Index Count Change</code>, e.g. the number of interfaces, without checking sysUptime. It is of particular interest in cases, where indexed entries may change without the need of a reboot. As modern operating systems seldom require reboots for system configuration changes, you may want to consider this setting for many cases (e.g. creating of a new filesystem without a reboot). The index to be considered is defined by the according XML file.</p>
<p>If the method is set to <code>Verify All Fields</code>, all indexes of the data source are checked for changes. This is of particular interest e.g. in cases, where the index is non-numeric (e.g. a MAC address). It should be noted that in the 1.0 and 1.1 releases, this method was found to be broken and has been corrected since 1.2.</p>
<p>If you feel the need for manual re-indexing, you may run it from CLI. Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q poller_reindex_hosts.php --help
Cacti Reindex Host Script 1.2, Copyright 2004-2018 - The Cacti Group

usage: poller_reindex_hosts.php --id=[host_id|All] [--qid=[ID|All]] [--host-descr=[description]]
                           [-d] [-h] [--help] [-v] [--version]

--id=host_id             - The host_id to have data queries reindexed or &#39;All&#39; to reindex all hosts
--qid=query_id           - Only index on a specific data query id; defaults to &#39;All&#39;
--host-descr=description - The host description to filter by (SQL filters acknowledged)
--debug                  - Display verbose output during execution
-v --version             - Display this help message
-h --help                - Display this help message
</code></pre>
<p>Running it in debug mode for the host with <code>id=2</code> may yield</p>
<pre class="console"><code>shell&gt;php -q poller_reindex_hosts.php -id=2 -d
WARNING: Do not interrupt this script.  Reindexing can take quite some time
DEBUG: There are &#39;1&#39; data queries to run
DEBUG: Data query number &#39;1&#39; host: &#39;2&#39; SNMP Query Id: &#39;1&#39; starting
DEBUG: Data query number &#39;1&#39; host: &#39;2&#39; SNMP Query Id: &#39;1&#39; ending
</code></pre>
<p>A silent run for all devices is issued by</p>
<pre class="console"><code>shell&gt;php -q poller_reindex_hosts.php -id=All
WARNING: Do not interrupt this script.  Reindexing can take quite some time
.....shell&gt;
</code></pre>
<p>You may run this script against a specific data query id using <code>--qid=[data query id]</code> like</p>
<pre class="console"><code>shell&gt;php -q poller_reindex_hosts.php --id=All --qid=1 -d
WARNING: Do not interrupt this script.  Reindexing can take quite some time
DEBUG: There are &#39;3&#39; data queries to run
DEBUG: Data query number &#39;1&#39; host: &#39;1&#39; SNMP Query Id: &#39;1&#39; starting
DEBUG: Data query number &#39;1&#39; host: &#39;1&#39; SNMP Query Id: &#39;1&#39; ending
DEBUG: Data query number &#39;2&#39; host: &#39;2&#39; SNMP Query Id: &#39;1&#39; starting
DEBUG: Data query number &#39;2&#39; host: &#39;2&#39; SNMP Query Id: &#39;1&#39; ending
DEBUG: Data query number &#39;3&#39; host: &#39;15&#39; SNMP Query Id: &#39;1&#39; starting
DEBUG: Data query number &#39;3&#39; host: &#39;15&#39; SNMP Query Id: &#39;1&#39; ending
</code></pre>
<p>It is possible, to select a host based on its host description using <code>--host-descr=[host description]</code>. It is allowed to apply an SQL filter expression for the description like <code>--qid=some%descr</code>. Use this parameter in conjunction with either <code>--id=[host id]</code> or <code>--qid=[data query id]</code> or both:</p>
<pre class="console"><code>shell&gt;php -q poller_reindex_hosts.php --id=All --qid=1 --host-descr=ga%f -d
WARNING: Do not interrupt this script.  Reindexing can take quite some time
DEBUG: There are &#39;1&#39; data queries to run
DEBUG: Data query number &#39;1&#39; host: &#39;2&#39; SNMP Query Id: &#39;1&#39; starting
DEBUG: Data query number &#39;1&#39; host: &#39;2&#39; SNMP Query Id: &#39;1&#39; ending
</code></pre>
<blockquote>
<p><strong>Caution</strong></p>
<p>Re-Indexing interferes with the poller operation. Make sure that the poller is not running and will not start during a reindex operation</p>
</blockquote>
<h2 id="empty-poller-output-table">Empty Poller Output Table</h2>
<p>During normal poller operation, all retrieved results are intermediately stored in the table named poller_output After execution of cmd.php or Spine, this table holds all results. The poller.php finally issues all rrdtool update operations. Thus, after polling has completed, the table should be empty.</p>
<p>Conditions may arise, where the table is not (completely) emptied. The most often known issue is lack of php memory. In those cases, the table is bigger than the php memory size, thus not all items are handled correctly. If that issue occurs, you may save all pending updates <em>after increasing PHP memory appropriately</em> by running this very script. Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q poller_output_empty.php --help
Cacti Empty Poller Output Table Script 1.0, Copyright 2004-2018 - The Cacti Group

usage: poller_output_empty.php [-h] [--help] [-v] [--version]

-v --version  - Display this help message
-h --help     - Display this help message
</code></pre>
<p>You see, no parameter is required for operating successfully. Under normal circumstances, running this script should yield</p>
<pre class="console"><code>shell&gt;php -q poller_output_empty.php
There were 0, RRD updates made this pass
shell&gt;
</code></pre>
<p>In case, you hit the poller process or if the table was really not fully processed, you may find</p>
<pre class="console"><code>shell&gt;php -q poller_output_empty.php
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.04
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.00 r:0.05
OK u:0.00 s:0.01 r:0.06
There were 21, RRD updates made this pass
shell&gt;
</code></pre>
<p>If logging level verbosity was switched to <code>DEBUG</code> you may find additional debug messages that usually show up in <code>cacti.log</code></p>
<h2 id="reapply-suggested-names-to-graphs">Reapply Suggested Names to Graphs</h2>
<p>For a general understanding of suggested names used with data queries, please see ?. Be aware, that changes to the <code>Suggested Names</code> section of a data query will not automatically be propagated to all existing graphs. This is, where poller_graphs_reapply_names.php drops in. Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q poller_graphs_reapply_names.php --help
Cacti Reapply Graph Names Script 1.0, Copyright 2004-2018 - The Cacti Group

usage: poller_graphs_reapply_names.php -id=[host_id|All][host_id1|host_id2|...] [-s=[search_string] [-d] [-h] [--help] [-v] [--version]

-id=host_id   - The host_id or &#39;All&#39; or a pipe delimited list of host_id&#39;s
-s=search_str - A graph template name or graph title to search for
-d            - Display verbose output during execution
-v --version  - Display this help message
-h --help     - Display this help message
</code></pre>
<p>Assume a situation, where the suggested names where changed for the standard data query named <code>SNMP - Get Mounted Partitions</code>. In this case, you will want to rework all graphs for this data query only. A verbose run will yield</p>
<pre class="console"><code>shell&gt;php -q poller_graphs_reapply_names.php -id=All -d -s=&quot;Used space&quot;
WARNING: Do not interrupt this script.  Interrupting during rename can cause issues
DEBUG: There are &#39;6&#39; Graphs to rename
DEBUG: Graph Name &#39;Localhost - Used Space - Memory Buffers&#39; starting
DEBUG: Graph Rename Done for Graph &#39;Localhost - Used Space - Memory Buffers&#39;
DEBUG: Graph Name &#39;Localhost - Used Space - Real Memory&#39; starting
DEBUG: Graph Rename Done for Graph &#39;Localhost - Used Space - Real Memory&#39;
DEBUG: Graph Name &#39;Localhost - Used Space - Swap Space&#39; starting
DEBUG: Graph Rename Done for Graph &#39;Localhost - Used Space - Swap Space&#39;
DEBUG: Graph Name &#39;Localhost - Used Space - /&#39; starting
DEBUG: Graph Rename Done for Graph &#39;Localhost - Used Space - /&#39;
DEBUG: Graph Name &#39;Localhost - Used Space - /sys&#39; starting
DEBUG: Graph Rename Done for Graph &#39;Localhost - Used Space - /sys&#39;
DEBUG: Graph Name &#39;Localhost - Used Space - /boot&#39; starting
DEBUG: Graph Rename Done for Graph &#39;Localhost - Used Space - /boot&#39;
</code></pre>
<p>Notice the miss-spelling of the word “Space”. The <code>-s=</code> option is not case sensitive.</p>
<h2 id="copy-local-cacti-users">Copy Local Cacti Users</h2>
<p>For use and understanding the limitation of this script, it is of importance to read <a href="User-Management.html">User Management</a></p>
<p>Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q copy_user.php --help
Cacti Copy User Utility, Version 1.2.0, Copyright (C) 2004-2018 The Cacti Group
usage: copy_cacti_user.php &lt;template user&gt; &lt;new user&gt;

A utility to copy on local Cacti user and their settings to a new one.

NOTE: It is highly recommended that you use the web interface to copy users as
this script will only copy Local Cacti users.
</code></pre>
<p>Now let's create a new user Harry Potter as follows</p>
<pre class="console"><code>shell&gt;php -q copy_user.php guest &quot;Harry Potter&quot;
Template User: guest
New User:      Harry Potter

Copying User...
User copied...
</code></pre>
<p>Find the results of this program call at User Management</p>
<table>
<thead>
<tr class="header">
<th>User Name**</th>
<th>Full Name</th>
<th>Enabled</th>
<th>Realm</th>
<th>Default Graph Policy</th>
<th>Last Login</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>admin</td>
<td>Administrator</td>
<td>Yes</td>
<td>Local</td>
<td>ALLOW</td>
<td>Sunday, October 07, 2007 14:59:32</td>
</tr>
<tr class="even">
<td>guest</td>
<td>Guest Account</td>
<td>Yes</td>
<td>Local</td>
<td>ALLOW</td>
<td>N/A</td>
</tr>
<tr class="odd">
<td>Harry Potter</td>
<td>Guest Account</td>
<td>Yes</td>
<td>Local</td>
<td>ALLOW</td>
<td>N/A</td>
</tr>
</tbody>
</table>
<h2 id="add-a-new-device">Add a New Device</h2>
<p>While it is an easy task to add a new device from the panels, this would be a tedious task for creating dozens of hundreds of devices in one turn. This is, where the script <code>add_device.php</code> comes in. First, let's have a look at the whole list of features it provides. Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q add_device.php --help
Add Device Script 1.0, Copyright 2004-2018 - The Cacti Group

A simple command line utility to add a device in Cacti

usage: add_device.php --description=[description] --ip=[IP] --template=[ID] [--notes=&quot;[]&quot;] [--disable]
        [--avail=[ping]] --ping_method=[icmp] --ping_port=[N/A, 1-65534] --ping_retries=[2]
        [--version=[1|2|3]] [--community=] [--port=161] [--timeout=500]
        [--username= --password=] [--authproto=] [--privpass= --privproto=] [--context=]
        [--quiet]

    Required:
        --description  the name that will be displayed by Cacti in the graphs
        --ip           self explanatory (can also be a FQDN)
    Optional:
        --template     0, is a number (read below to get a list of templates)
        --notes        &#39;&#39;, General information about this host.  Must be enclosed using double quotes.
        --disable      0, 1 to add this host but to disable checks and 0 to enable it
        --avail        pingsnmp, [ping][none, snmp, pingsnmp]
        --ping_method  tcp, icmp|tcp|udp
        --ping_port    &#39;&#39;, 1-65534
        --ping_retries 2, the number of time to attempt to communicate with a host
        --version      1, 1|2|3, snmp version
        --community    &#39;&#39;, snmp community string for snmpv1 and snmpv2.  Leave blank for no community
        --port         161
        --timeout      500
        --username     &#39;&#39;, snmp username for snmpv3
        --password     &#39;&#39;, snmp password for snmpv3
        --authproto    &#39;&#39;, snmp authentication protocol for snmpv3
        --privpass     &#39;&#39;, snmp privacy passphrase for snmpv3
        --privproto    &#39;&#39;, snmp privacy protocol for snmpv3
        --context      &#39;&#39;, snmp context for snmpv3

    List Options:
        --list-host-templates
        --list-communities
        --quiet - batch mode value return
</code></pre>
<p>Wow, that's quite a lot of options. To better understand it's use, let's first stick to the listing options</p>
<h3 id="list-all-host-templates">List all Host Templates</h3>
<pre class="console"><code>shell&gt;php -q add_device.php --list-host-templates

Valid Host Templates: (id, name)
1       Generic SNMP-enabled Host
3       ucd/net SNMP Host
4       Karlnet Wireless Bridge
5       Cisco Router
6       Netware 4/5 Server
7       Windows 2000/XP Host
8       Local Linux Machine
</code></pre>
<p>Why are those <code>Host Templates</code> of such importance for this script? Well, when using this script to add a new device, there are 3 required parameters. The <code>description</code> and the <code>device ip address</code> are of course left to you. But for assigning the correct <code>Host Template Id</code>, you should first know the correct id of that very parameter. For the purpose of this chapter we assume to add a device that will be associated to a <code>ucd/net SNMP Host</code>, so the id of <code>3</code> is required.</p>
<p>If you do not want to associate the host to any <code>Host Template Id</code>, known as host template None, either provide the parameter <code>--template=0</code> or omit this parameter.</p>
<h3 id="list-all-community-strings">List all Community Strings</h3>
<pre class="console"><code>shell&gt;php -q add_device.php --list-communities

Known communities are: (community)
    public
    snmp-get
</code></pre>
<p>Of course, your list will vary</p>
<h3 id="create-a-new-device">Create a New Device</h3>
<p>Now, let's set up the most basic command to add a new device. The description shall be <code>"Device Add Test"</code>, the ip will be given as a FQDN, <code>router.mydomain.com</code>. As a SNMP enabled device, surely a community string has to be provided; in this case given as <code>public</code>. In total, this makes the following command</p>
<pre class="console"><code>shell&gt;php -q add_device.php --description=&quot;Device Add Test&quot; --ip=&quot;router.mydomain.com&quot; --template=3 --community=&quot;public&quot;

Adding Device Add Test (router.mydomain.com) as &quot;ucd/net SNMP Host&quot; using SNMP v1 with community &quot;public&quot;
Success - new device-id: (11)
</code></pre>
<p>Go to Devices to see the result:</p>
<table>
<thead>
<tr class="header">
<th>Description**</th>
<th>Graphs</th>
<th>Data Sources</th>
<th>Status</th>
<th>Hostname</th>
<th>Current (ms)</th>
<th>Average (ms)</th>
<th>Availability</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Device Add Test</td>
<td>0</td>
<td>0</td>
<td>Unknown</td>
<td>router.mydomain.com</td>
<td>0</td>
<td>0</td>
<td>100</td>
</tr>
</tbody>
</table>
<p>Use any other combination of parameters in the same way as via the web browser console. You may want to remember the new device id, <code>11</code> in this case, for the next steps.</p>
<h2 id="associate-a-data-query-to-an-existing-host">Associate a Data Query to an existing Host</h2>
<p>It is recommended to maintain data query associations by maintaining host templates. Each time, a data query is added to a host template, it will automatically associated with all hosts related to that very host template. The data query will be executed as well; this way the snmp cache will be filled with all values related to that query.</p>
<p>Nevertheless, it is sometimes suitable to manually associate a certain data query with a single host only without changing any host template. This is, where the script <code>add_data_query.php</code> comes in. First, let's have a look at the whole list of features it provides. Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q add_data_query.php --help

Add Data Query Script 1.0, Copyright 2004-2018 - The Cacti Group

A simple command line utility to add a data query to an existing device in Cacti

usage: add_data_query.php --host-id=[ID] --data-query-id=[dq_id] --reindex-method=[method] [--quiet]

Required:
        --host-id         the numerical ID of the host
        --data-query-id   the numerical ID of the data_query to be added
        --reindex-method  the reindex method to be used for that data query
                          0|None   = no reindexing
                          1|Uptime = Uptime goes Backwards
                          2|Index  = Index Count Changed
                          3|Fields = Verify all Fields
List Options:
        --list-hosts
        --list-data-queries
        --quiet - batch mode value return

If the data query was already associated, it will be reindexed.
</code></pre>
<p>Let's first stick to the listing options</p>
<h3 id="list-all-hosts">List all Hosts</h3>
<pre class="console"><code>shell&gt;php -q add_data_query.php --list-hosts

Known Hosts: (id, hostname, template, description)
1       127.0.0.1       8       Localhost
11      router          3       router.mydomain.com
</code></pre>
<h3 id="list-all-data-queries">List all Data Queries</h3>
<pre class="console"><code>shell&gt;php -q add_data_query.php --list-data-queries

Known SNMP Queries:(id, name)
1       SNMP - Interface Statistics
2       ucd/net -  Get Monitored Partitions
3       Karlnet - Wireless Bridge Statistics
4       Netware - Get Available Volumes
6       Unix - Get Mounted Partitions
7       Netware - Get Processor Information
8       SNMP - Get Mounted Partitions
9       SNMP - Get Processor Information
</code></pre>
<h3 id="add-a-data-query">Add a Data Query</h3>
<pre class="console"><code>shell&gt;php -q add_data_query.php --host-id=11 --data-query-id=1 --reindex-method=fields
Success - Host (11: router.mydomain.com) data query (1: SNMP - Interface Statistics) reindex method (3: Verify All Fields)
</code></pre>
<p>This example shows the use of a string <code>"fields"</code> for specifying the reindex method. As given by the help text, the use of the numeric value of <code>"3"</code> would have given the exact same result. When visiting the device edit panel, you will find non-zero values for the data query status column, e.g. <em>Success [41 Items, 5 Rows]</em>.</p>
<h2 id="associate-a-graph-template-to-an-existing-host">Associate a Graph Template to an existing Host</h2>
<p>It is recommended to maintain graph template associations by maintaining host templates. Each time, a graph template is added to a host template, it will automatically associated with all hosts related to that very host template.</p>
<p>Nevertheless, it is sometimes suitable to manually associate a certain graph template with a single host only without changing any host template. This is, where the script <code>add_graph_template.php</code> comes in. First, let's have a look at the whole list of features it provides. Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q add_graph_template.php --help

Add Graph Template Script 1.0, Copyright 2004-2018 - The Cacti Group

A simple command line utility to associate a graph template with a host in Cacti

usage: add_graph_template.php --host-id=[ID] --graph-template-id=[ID]
        [--quiet]

Required:
        --host-id             the numerical ID of the host
        --graph_template-id   the numerical ID of the graph template to be added

List Options:
        --list-hosts
        --list-graph-templates
        --quiet - batch mode value return
</code></pre>
<p>Let's first stick to the listing options</p>
<h3 id="list-all-hosts-for-a-graph-template">List all Hosts for a graph template</h3>
<pre class="console"><code>shell&gt;php -q add_graph_template.php --list-hosts

Known Hosts: (id, hostname, template, description)
1       127.0.0.1       8       Localhost
11      router          3       router.mydomain.com
</code></pre>
<h3 id="list-all-graph-template">List all Graph Template</h3>
<pre class="console"><code>shell&gt;php -q add_graph_template.php --list-graph-templates

Known Graph Templates:(id, name)
2       Interface - Traffic (bits/sec)
3       ucd/net - Available Disk Space
4       ucd/net - CPU Usage
5       Karlnet - Wireless Levels
6       Karlnet - Wireless Transmissions
7       Unix - Ping Latency
8       Unix - Processes
9       Unix - Load Average
10      Unix - Logged in Users
11      ucd/net - Load Average
...
</code></pre>
<h3 id="add-a-graph-template">Add a Graph Template</h3>
<pre class="console"><code>shell&gt;php -q add_graph_template.php --host-id=11 --graph-template-id=7

Success: Graph Template associated for host: (11: router) - graph-template: (7: Unix - Ping Latency)
</code></pre>
<h2 id="add-a-new-graph">Add a New Graph</h2>
<p>You won't stop now as you've just created a device from cli. Surely, the task of setting up graphs is the next step. This is done using <code>add_graphs.php</code>. Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php
Add Graphs Script 1.2, Copyright 2008 - The Cacti Group

A simple command line utility to add graphs in Cacti

usage: add_graphs.php --graph-type=[cg|ds] --graph-template-id=[ID]
        --host-id=[ID] [--graph-title=title] [graph options] [--force] [--quiet]

For cg graphs:
        [--input-fields=&quot;[data-template-id:]field-name=value ...&quot;] [--force]

        --input-fields  If your data template allows for custom input data, you may specify that
                        here.  The data template id is optional and applies where two input fields
                        have the same name.
        --force         If you set this flag, then new cg graphs will be created, even though they
                        may already exist

For ds graphs:
        --snmp-query-id=[ID] --snmp-query-type-id=[ID] --snmp-field=[SNMP Field] --snmp-value=[SNMP Value]

        [--graph-title=]       Defaults to what ever is in the graph template/data-source template.

        [--reindex-method=]    the reindex method to be used for that data query
                               if data query already exists, the reindex method will not be changed
                        0|None   = no reindexing
                        1|Uptime = Uptime goes Backwards (Default)
                        2|Index  = Index Count Changed
                        3|Fields = Verify all Fields
List Options:
        --list-hosts
        --list-graph-templates [--host_template=[ID]]
        --list-input-fields --graph-template-id=[ID]
        --list-snmp-queries
        --list-query-types  --snmp-query-id [ID]
        --list-snmp-fields  --host-id=[ID] [--snmp-query-id=[ID]]
        --list-snmp-values  --host-id=[ID] [--snmp-query-id=[ID]] --snmp-field=[Field]

    &#39;cg&#39; graphs are for things like CPU temp/fan speed, while
    &#39;ds&#39; graphs are for data-source based graphs (interface stats etc.)
</code></pre>
<p>Like the graph creation from the console, this task is split into two different ones:</p>
<ul>
<li><p><strong>Associated Graph Templates:</strong> These are named <code>cg</code> graph_type for this script.</p></li>
<li><p><strong>Associated Data Queries:</strong> These are named <code>ds</code> graph_type for this script. Additional SNMP parameters are required to define those graphs.</p></li>
</ul>
<blockquote>
<p><strong>Caution</strong></p>
<p>When running this cli script, caution must be taken to avoid typos. Sometimes, list options take an ending “s”, where the option for graph creation comes without “s”. Error messages are not issued to indicate this typo; instead you will see the general help screen.</p>
</blockquote>
<h3 id="list-options-for-associated-graph-templates">List Options for Associated Graph Templates</h3>
<p>The first list option, <code>--list-hosts</code>, is required only if you do not know the <code>id</code> of the device you want to add graphs for. It will produce output as follows</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --list-hosts

Known Hosts: (id, hostname, template, description)
...
11      router.mydomain.com 3       Device Add Test
</code></pre>
<p>You surely recognize the device we've just added?</p>
<p>The next list option, <code>--list-graph-templates</code>, is required to identify the number of an <code>Associated Graph Templates</code>.</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --list-graph-templates

Known Graph Templates:(id, name)
2       Interface - Traffic (bits/sec)
3       ucd/net - Available Disk Space
4       ucd/net - CPU Usage
5       Karlnet - Wireless Levels
6       Karlnet - Wireless Transmissions
7       Unix - Ping Latency
8       Unix - Processes
9       Unix - Load Average
...
</code></pre>
<p>We will need the graph template id of the <code>ucd/net - CPU Usage</code> template later. So note the number <code>4</code> for it.</p>
<p>It is possible to reduce the listing to the graph templates associated with a specific host template by using <code>--list-graph-templates --host-template-id=[id]</code>. For a "ucd/net SNMP Host" this yields</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --list-graph-templates --host-template-id=3

Known Graph Templates:(id, name)
4   ucd/net - CPU Usage
11  ucd/net - Load Average
13  ucd/net - Memory Usage...
</code></pre>
<h3 id="list-options-for-associated-data-queries">List Options for Associated Data Queries</h3>
<p>First task is to find all id's for available data queries.</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --host-id=2 --list-snmp-queries

Known SNMP Queries:(id, name)
1       SNMP - Interface Statistics
2       ucd/net -  Get Monitored Partitions
3       Karlnet - Wireless Bridge Statistics
4       Netware - Get Available Volumes
6       Unix - Get Mounted Partitions
7       Netware - Get Processor Information
8       SNMP - Get Mounted Partitions
9       SNMP - Get Processor Information
</code></pre>
<p>For standard interface statistics, we note the id of <code>1</code></p>
<p>Next task is to find the query_type as done by issuing</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --snmp-query-id=1 --list-query-types

Known SNMP Query Types: (id, name)
2       In/Out Errors/Discarded Packets
3       In/Out Non-Unicast Packets
4       In/Out Unicast Packets
9       In/Out Bytes (64-bit Counters)
13      In/Out Bits
14      In/Out Bits (64-bit Counters)
16      In/Out Bytes
20      In/Out Bits with 95th Percentile
21      In/Out Bits with Total Bandwidth
22      In/Out Bytes with Total Bandwidth
23      In/Out Bits 1 min
24      In/Out Bits 1 min (64-bit Counters)
</code></pre>
<p>For a standard <code>In/Out Bits</code> type, we note the id of <code>13</code></p>
<p>Next issue is to select the <code>SNMP Field</code> that shall be used for a new graph.</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --host-id=11 --list-snmp-fields

Known SNMP Fields for host-id 11: (name)
ifAlias
ifDescr
ifHwAddr
ifIndex
ifIP
ifName
ifOperStatus
ifSpeed
ifType
</code></pre>
<p>For our graph, we will use the field <code>ifOperStatus</code> to select the correct interfaces.</p>
<p>In general, you will next determine the values available for the <code>SNMP Field</code>, in our case <code>ifOperStatus</code>. This is done by</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --host-id=11 --snmp-field=ifOperStatus --list-snmp-values

Known values for ifOperStatus for host 11: (name)
Down
Up
</code></pre>
<p>This is no surprise, of course. Now, all parameters required for creating a new graph are determined.</p>
<h3 id="add-non-indexed-graphs">Add Non-Indexed Graphs</h3>
<p>We will create a graph for <code>ucd/net - CPU Usage</code>. Above, we've identified the graph template it to be <code>4</code>. In total, that makes up for the following command</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --host-id=11 --graph-type=cg --graph-template-id=4

Graph Added - graph-id: (39) - data-source-id: (63)
</code></pre>
<p>Find the result when visiting Graph Management</p>
<table>
<thead>
<tr class="header">
<th>Graph Title**</th>
<th>Template Name</th>
<th>Size</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Device Add Test - CPU Usage</td>
<td>ucd/net - CPU Usage</td>
<td>120x500</td>
</tr>
</tbody>
</table>
<p>If the graph template was not associated with that host before, it is now added to the list of Associated Graph Templates.</p>
<h3 id="add-indexed-graphs">Add Indexed Graphs</h3>
<p>First, let's sum up the id's of all resources required for this task:</p>
<h6 id="table-20-2-parameters-required-for-an-interface-traffic-graph">Table 20-2. Parameters required for an Interface Traffic Graph</h6>
<table>
<thead>
<tr class="header">
<th>Object</th>
<th>Value</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Graph Template Id</td>
<td>2</td>
<td>Interface - Traffic (bits/sec)</td>
</tr>
<tr class="even">
<td>SNMP Query Id</td>
<td>1</td>
<td>SNMP - Interface Statistics</td>
</tr>
<tr class="odd">
<td>SNMP Query Type Id</td>
<td>13</td>
<td>In/Out Bits</td>
</tr>
<tr class="even">
<td>SNMP Field</td>
<td>ifOperStatus</td>
<td>Field name</td>
</tr>
<tr class="odd">
<td>SNMP Value</td>
<td>Up</td>
<td>Field value</td>
</tr>
</tbody>
</table>
<p>This will make up for the following command</p>
<pre class="console"><code>shell&gt;php -q add_graphs.php --host-id=11 --graph-type=ds --graph-template-id=2 --snmp-query-id=1 --snmp-query-type-id=13 --snmp-field=ifOperStatus --snmp-value=Up

Graph Added - graph-id: (40) - data-source-id: (65)
</code></pre>
<p>Find the result when visiting Graph Management</p>
<table>
<thead>
<tr class="header">
<th>Graph Title**</th>
<th>Template Name</th>
<th>Size</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Device Add Test - CPU Usage</td>
<td>ucd/net - CPU Usage</td>
<td>120x500</td>
</tr>
<tr class="even">
<td>Device Add Test - Traffic - lo</td>
<td>Interface - Traffic (bits/sec)</td>
<td>120x500</td>
</tr>
</tbody>
</table>
<p>If the data query was not associated with that host before, it is now added to the list of Associated Graph Templates. In this case, the Re-Index Method of <code>Uptime Goes Backwards</code> is defaulted if not given otherwise. You may provide a different Re-Index Method by entering the optional parameter <code>--reindex-method</code>.</p>
<h2 id="add-items-to-a-tree">Add Items to a Tree</h2>
<p>Now, that we've created some nice graphs, they should be put the graph trees. This is done using <code>add_tree.php</code>. As you will notice soon, it is possible to even add header items, hosts and graphs to a tree as well as adding a new tree itself. But let us first see the help output. Calling the script with the parameter <code>--help</code> yields</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --help

Add Tree Script 1.0, Copyright 2004-2018 - The Cacti Group

A simple command line utility to add objects to a tree in Cacti

usage: add_tree.php  --type=[tree|node] [type-options] [--quiet]

Tree options:
        --name=[Tree Name]
        --sort-method=[manual|alpha|natural|numeric]

Node options:
        --node-type=[header|host|graph]
        --tree-id=[ID]
        [--parent-node=[ID] [Node Type Options]]

Header node options:
        --name=[Name]

Host node options:
        --host-id=[ID]
        [--host-group-style=[1|2]]
        (host group styles:
         1 = Graph Template,
         2 = Data Query Index)

Graph node options:
        --graph-id=[ID]
        [--rra-id=[ID]]

List Options:
        --list-hosts
        --list-trees
        --list-nodes --tree-id=[ID]
        --list-rras
        --list-graphs --host-id=[ID]
</code></pre>
<h3 id="list-hosts">List Hosts</h3>
<p>The first try is dedicated to the list option <code>--list-hosts</code>. It goes like</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --list-hosts

Known Hosts: (id, hostname, template, description)
1       127.0.0.1           8       Localhost
2       gandalf         3       gandalf
...
11      router.mydomain.com 3       Device Add Test
</code></pre>
<h3 id="list-trees">List Trees</h3>
<p>Now, let us <code>--list-trees</code>. It goes like</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --list-trees

Known Trees:
id      sort method                     name
1       Manual Ordering (No Sorting)    Default Tree
</code></pre>
<h3 id="list-nodes">List Nodes</h3>
<p>Listing all existend node of a given tree is done by</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --list-nodes --tree-id=1

Known Tree Nodes:
type    id      text
Host    7       127.0.0.1       Graph Template
Host    9       gandalf     Graph Template
Host    12      gandalf     Graph Template
</code></pre>
<h3 id="list-rras">List RRAs</h3>
<p>For special tree add options, you will require the id of the RRA definition to completely specify the add request. That's why the corresponding <code>--list-rras</code> option is implemented. It goes this way</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --list-rras

Known RRAs:
id      steps   rows    timespan        name
1       1       600     86400           Daily (5 Minute Average)
2       6       700     604800          Weekly (30 Minute Average)
3       24      775     2678400         Monthly (2 Hour Average)
4       288     797     33053184        Yearly (1 Day Average)
</code></pre>
<h3 id="list-graphs-for-given-hosts">List Graphs for given Hosts</h3>
<p>To be able to add a Graph, the id of that very graph is required. Thus, a <code>--list-graphs --host-id=[id]</code> option was implemented</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --list-graphs --host-id=1

Known Host Graphs: (id, name, template)
1       Localhost - Memory Usage            Linux - Memory Usage
2       Localhost - Load Average            Unix - Load Average
3       Localhost - Logged in Users         Unix - Logged in Users
4       Localhost - Processes           Unix - Processes
5       Localhost - Traffic - eth0          Interface - Traffic (bits/sec, 95th Percentile)
33      Localhost - Used Space - Memory Buffers Host MIB - Available Disk Space
34      Localhost - Used Space - Real Memory    Host MIB - Available Disk Space
35      Localhost - Used Space - Swap Space     Host MIB - Available Disk Space
36      Localhost - Used Space - /          Host MIB - Available Disk Space
37      Localhost - Used Space - /sys       Host MIB - Available Disk Space
38      Localhost - Used Space - /boot      Host MIB - Available Disk Space
</code></pre>
<h3 id="add-a-new-tree">Add a new Tree</h3>
<p>Cacti comes with a single tree, named Default Tree. Console entry Graph Trees is used to add more trees. With <code>add_tree.php</code>, you may now do so from command line as well:</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=tree --name=&quot;Test Tree Add&quot; --sort-method=manual

Tree Created - tree-id: (6)
</code></pre>
<p>Verify this from console, Graph Trees to find</p>
<pre class="console"><code>Default Tree
Test Tree Add
</code></pre>
<p>as expected.</p>
<h3 id="add-a-new-header-node-to-a-tree">Add a new Header Node to a Tree</h3>
<p>Now, that a new tree has been created, you may want to add a new header to that very tree. Use</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=node --node-type=header --tree-id=6 --name=&quot;Header Test&quot;

Added Node node-id: (21)
</code></pre>
<p>You will want to save the id returned if willing to add further nodes to exactly this new Header Node</p>
<p>Please note that it is currently not possible to add another header with the same options even if this is possible from console</p>
<p>But it is possible to add a subheader to an already defined header. Even in this case, the <code>name</code> has to be unique</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=node --node-type=header --tree-id=6 --parent-node=21  --name=&quot;SubHeader Test&quot;

Added Node node-id: (22)
</code></pre>
<h3 id="add-a-new-host-node-to-a-tree">Add a new Host Node to a Tree</h3>
<p>We will distinguish several options adding a host to a tree. First, let's add a Host directly to a tree. For this example, we use the tree id returned from adding our own <code>Test Tree Add</code> known with <code>id=6</code></p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=node --node-type=host --tree-id=6 --host-id=1

Added Node node-id: (23)
</code></pre>
<p>As no <code>--parent-node</code> was given, this host is directly added to the tree itself. If you wish to add a host to a (sub)header specify as follows</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=node --node-type=host --tree-id=6 --parent-node=21 --host-id=1

Added Node node-id: (24)
</code></pre>
<p>Both example come without a <code>--host-group-style</code> option. For those cases, <code>Graph Template</code> host group style is default. Here's an example for providing a host group option of <code>Data Query Index</code> instead</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=node --node-type=host --tree-id=6 --parent-node=22 --host-id=1 --host-group-style=2

Added Node node-id: (25)
</code></pre>
<h3 id="add-a-new-graph-node-to-a-tree">Add a new Graph Node to a Tree</h3>
<p>Like above, instead of hosts it is possible to add a single graph to a tree or a (sub)header of any tree. Of course, you again will require the <code>id</code> of the tree and optionally of the <code>header</code>. This results in</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=node --node-type=graph --tree-id=6 --graph-id=5

Added Node node-id: (26)
</code></pre>
<p>Like above, this graph now was added directly to the tree itself. To add a graph to a header, proceed as follows</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=node --node-type=graph --tree-id=6 --parent-node=21 --graph-id=5

Added Node node-id: (27)
</code></pre>
<p>In both cases, no explicit <code>--rra-id</code> was given. This will default to the Daily (5 Minute Average). Specify any other <code>--rra-id</code> as given</p>
<pre class="console"><code>shell&gt;php -q add_tree.php --type=node --node-type=graph --tree-id=6 --parent-node=21 --graph-id=1 --rra-id=4

Added Node node-id: (28)
</code></pre>
<p>to provide the <code>--rra-id</code> for a rra of Yearly (1 Day Average).</p>
<h2 id="add-graph-permissions">Add Graph Permissions</h2>
<p>This script is used to specify special graph permissions to users. The list of parameters is displayed as usual when calling the script with the parameter <code>--help</code></p>
<pre class="console"><code>shell&gt;php -q add_perms.php --help

Add Permissions Script 1.0, Copyright 2004-2018 - The Cacti Group

A simple command line utility to add permissions to tree items in Cacti

usage: add_perms.php [ --user-id=[ID] ]
        --item-type=[graph|tree|host|graph_template]
        --item-id [--quiet]

Where item-id is the id of the object of type item-type
List Options:
        --list-users
        --list-trees
        --list-graph-templates
        --list-graphs --host-id=[ID]
</code></pre>
<h3 id="list-users">List Users</h3>
<p>The list of users is retrieved by calling the script with the parameter <code>--list-users</code>. It goes like</p>
<pre class="console"><code>shell&gt;php -q add_perms.php --list-users

Known Users:
id      username        full_name
1       admin   Administrator
3       guest   Guest Account
</code></pre>
<h3 id="list-trees-who-accept-permissions">List Trees who accept permissions</h3>
<p>The list of trees is retrieved by calling the script with the parameter <code>--list-trees</code>. It goes like</p>
<pre class="console"><code>shell&gt;php -q add_perms.php --list-trees

Known Trees:
id      sort method                     name
1       Manual Ordering (No Sorting)    Default Tree
</code></pre>
<h3 id="list-graph-templates">List Graph Templates</h3>
<p>The list of available graph templates is retrieved by calling the script with the parameter <code>--list-graph-templates</code>. It goes like</p>
<pre class="console"><code>shell&gt;php -q add_perms.php --list-graph-templates

Known Graph Templates:(id, name)
2       Interface - Traffic (bits/sec)
3       ucd/net - Available Disk Space
4       ucd/net - CPU Usage
5       Karlnet - Wireless Levels
6       Karlnet - Wireless Transmissions
7       Unix - Ping Latency
8       Unix - Processes
9       Unix - Load Average
...
</code></pre>
<h3 id="list-graphs-for-given-hosts-where-permissions-can-be-set">List Graphs for given Hosts where permissions can be set</h3>
<p>To be able to add a permissions to a specific Graph, the id of that very graph is required. Thus, a <code>--list-graphs --host-id=[id]</code> option was implemented</p>
<pre class="console"><code>shell&gt;php -q add_perms.php --list-graphs --host-id=1

Known Host Graphs: (id, name, template)
1       Localhost - Memory Usage            Linux - Memory Usage
2       Localhost - Load Average            Unix - Load Average
3       Localhost - Logged in Users         Unix - Logged in Users
4       Localhost - Processes           Unix - Processes
5       Localhost - Traffic - eth0          Interface - Traffic (bits/sec, 95th Percentile)
33      Localhost - Used Space - Memory Buffers Host MIB - Available Disk Space
34      Localhost - Used Space - Real Memory    Host MIB - Available Disk Space
35      Localhost - Used Space - Swap Space     Host MIB - Available Disk Space
36      Localhost - Used Space - /          Host MIB - Available Disk Space
37      Localhost - Used Space - /sys       Host MIB - Available Disk Space
38      Localhost - Used Space - /boot      Host MIB - Available Disk Space
</code></pre>
<h3 id="add-graph-permissions-to-specific-users">Add Graph Permissions to specific Users</h3>
<p>There are various ways to define graph permissions to specific users. First, we will add graph permissions for a given host. This is done using the parameter <code>--item-type=host</code> as follows</p>
<pre class="console"><code>shell&gt;php -q add_perms.php --user-id=4 --item-type=host --item-id=1
</code></pre>
<p><code>--user-id=4</code> must specify an existing users. Else, an error message will be printed. As <code>--item-type=host</code> is given, <code>--item-id=1</code> must specify a valid host. Again, if no host with this specific id exists, an error message will be printed. No output is produced on successful operations.</p>
<p>Next, we will add graph permissions for a given tree. This is done using the parameter <code>--item-type=tree</code> as follows</p>
<pre class="console"><code>shell&gt;php -q add_perms.php --user-id=4 --item-type=tree --item-id=1
</code></pre>
<p><code>--user-id=4</code> must specify an existing users. Else, an error message will be printed. As <code>--item-type=tree</code> is given, <code>--item-id=1</code> must specify a valid tree (the Default Tree in this case). Again, if no tree with this specific id exists, an error message will be printed. No output is produced on successful operations.</p>
<p>Adding graph permissions for a given graph template is done using the parameter <code>--item-type=graph_template</code> as follows</p>
<pre class="console"><code>shell&gt;php -q add_perms.php --user-id=4 --item-type=graph_template --item-id=25
</code></pre>
<p><code>--user-id=4</code> must specify an existing users. Else, an error message will be printed. As <code>--item-type=graph_template</code> is given, <code>--item-id=1</code> must specify a valid graph_template (the Interface - Traffic (bytes/sec) in this case). Again, if no graph template with this specific id exists, an error message will be printed. No output is produced on successful operations.</p>
<p>Last but not least we add graph permissions for a given graph by using the parameter <code>--item-type=graph</code> as follows</p>
<pre class="console"><code>shell&gt;php -q add_perms.php --user-id=4 --item-type=graph --item-id=8
</code></pre>
<p><code>--user-id=4</code> must specify an existing users. Else, an error message will be printed. As <code>--item-type=graph</code> is given, <code>--item-id=1</code> must specify a valid graph. Again, if no graph template with this specific id exists, an error message will be printed. No output is produced on successful operations.</p>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
